#include "hack.h"

#include "algorithms.h"

#include <math.h>


BYTE TriangulateFireAngle(Vector &rel, Vector &vel, Sint32 scalar)
{
	double alpha, beta, theta, phi, s_vel;

	// alpha = arctan ( relative position comps )

	if (rel.x == 0)
	{
		alpha = PI / 2;
	}
	else
	{
		alpha = atan(rel.y / (double)rel.x);
	}

	// beta = arctan ( relative velocity comps )

	if (vel.x == 0)
	{
		beta = PI / 2;
	}
	else
	{
		beta = atan(vel.y / (double)vel.x);
	}

	// theta = sin ( alpha + beta )

	theta = sin(alpha + beta);

	// scalar = scalar velocity of weapon

	// s_vel = relative velocity scalar

	s_vel = sqrt(vel.x * vel.x + vel.y * vel.y);

	// phi = arcsin ( player velocity / weapon velocity * angle between ) + alpha

	phi = asin((s_vel / (double)scalar) * theta) + alpha;

	Vector t;
	t.set(1000, Sint32(tan(phi) * 1000));
	t *= sgn(rel.x);

	return TriangulateFireAngle(t);
}

BYTE TriangulateFireAngle(Vector &rel)
{
	double	dx = -rel.x,
			dy = rel.y;

	if (dy == 0)
		if (dx > 0)
			return 10;
		else
			return 30;

	double angle = atan(dx / dy) + PI;

	if (dy >= 0)
	{
		if (dx >= 0)
			angle -= PI;
		else
			angle += PI;
	}

	return BYTE(angle * 40.0 / TwoPI);
}

BYTE oppositeDirection(BYTE d)
{
	return (d + 20) % 40;
}

/*
String generateName()
{
	SS_LIGHT_PRNG prng(getTime());
	String s;
	Uint16 i;
	char str[2];
	str[1] = 0;

	for (Uint16 x = 0; x < 19; ++x)
	{
		i = prng.getNext();

		if (i & 1)
		{	// caps
			i = prng.getNext();
			*str = 'A' + (i % 26);
		}
		else
		{	// no caps
			i = prng.getNext();
			*str = 'a' + (i % 26);
		}

		s += str;
	}

	return s;
}

void dumpUptime()
{
	Uint32 time = GetTickCount();

	Uint32 minutes = time / (1000 * 60) % 60;
	Uint32 hours = time / (1000 * 60 * 60) % 24;
	Uint32 days = time / (1000 * 60 * 60 * 24);

	printf("System has been online for %i days %i hours %i minutes\n", days, hours, minutes);
}
*/
